/****************************************************************************
FICHERO:		cnjlib.h
AUTOR:		Patricio Garca Bez
FECHA:		Curso 92/93
FINALIDAD:	Cabeceras para utilizar con CNJLIB.C
HISTORIA:	Kiko. Adaptada y documentada 28.09.94
            Kiko. 30.11.95 La cabecera de la funcin cnjcpy no coincida
            con el cdigo de la implementacin de la funcin: los parmetros
            de la funcin estaban cambiados de orden.
            Se ha corregido este error.
BIBLIOGRAFIA:
MODO DE UTILIZACION:
****************************************************************************/
typedef unsigned long palabra;

typedef struct {				/* Estructura de un conjunto:  */
	unsigned longitud; 		/* Nmero de palabras que ocupa */
	palabra  *conj;    		/* Puntero a las palabras del conjunto */
} set;

/********************************* MACROS ***********************************/

/* Las macros PAL y BIT sirven para detectar en cual de las palabras y en qu
	bit de la palabra se almacena el bit de informacin correspondiente al
	elemento x del conjunto.
	Tngase en cuenta que sizeof(palabra) * BITS_EN_BYTE devuelve el nmero
	de bits de palabra. */

#define BITS_EN_BYTE 8		/* N de bits en un byte */
#define PAL(x)  ((x) / (sizeof(palabra) * BITS_EN_BYTE))
#define BIT(x)  ((x % (sizeof(palabra) * BITS_EN_BYTE)))


/************************ PROTOTIPOS DE FUNCIONES ***************************/

set *cnjini(unsigned num_ele);
/* Crea memoria para un conjunto con capacidad mxima de num_ele elementos */

int cnjper(set *cj1, unsigned e);
/* Indica <>0  0 segun el elemento nmero e est o no en el conjunto cj1 */

void cnjins(set *cj, unsigned e);
/* Aade el elemento nmero e al conjunto cj */

void cnjvac(set *cj);
/* Inicializa a vacio el conjunto cj */

void cnjcpy(set *cjorg, set *cjdest);
/* Copia el conjunto cjorg en el conjunto cjdest */

void cnjuni( set *cjdest, set *cjorg);
/* Aade los elelmentos del conjunto cjorg en el conjunto cjdest */

int cnjcmp(set *cj1, set *cj2);
/* Devuelve <>0  0 segn sean iguales o no los conjuntos cj1 y cj2 */

void cnjlib(set *cj);
/* Libera la memoria reservada a un conjunto mediante cnjini */

int cnjigu(set *cj1, set *cj2);
/*  Devuelve 1 si los dos conjuntos son iguales; 0 en otro caso */
