/***************************************************************************/
/* Prctica n 3	Gestin de una pila                                      */
/*                                                                         */
/* Fecha: 5 Noviembre 1996                                                 */
/*                                                                         */
/* Autor: Oscar Martnez Valpuesta                                         */
/*                                                                         */
/* Comentarios: Se pretende implementar la rutinas necesarias para la      */
/*	      gestin de una pila: inicializacin, inserccin, extraccin,      */
/*	      eliminacin, etc.                                                 */
/***************************************************************************/
#include <stdio.h> 		/* printf, scanf */
#include <stdlib.h>		/* calloc, exit */
#include <conio.h>		/* clrscr */

/* Macro que devuelve 1 si la pila est vaca. El parmetro que se le pasa
 es el top de la pila.                                                 */
#define PILA_VACIA(X) ((X == NULL) ? 1 : 0)

/* Macro que devuelve el nmero de elementos de la pila. Este n se calcula
 restando al puntero al top el puntero a la base y sumando 1 ya que si solo
 hay un elemento la resta dara 0.                                        */
#define NUMELPILA(X) ((X -> s == NULL) ? 0 : ((unsigned)(X -> s - X -> st) + 1))


typedef unsigned elemento;
typedef struct {
	  elemento *st,		/* puntero a la base */
		   *sb,         /* puntero al lmite superior */
		   *s;          /* puntero al top */
} PILA;

/* prototipos */
PILA *initPila(unsigned N);
void push(PILA *pila, elemento e);
void pop(PILA *pila, elemento *e);
void Libera_pila(PILA *pila);

/***************************************************************************/
/* Funcin que reserva en primer lugar memoria para la estructura de la pila
 y si esto ha sido posible reserva memoria para los N elementos que contendr
 como mximo.                                                               */
/***************************************************************************/
PILA *initPila(unsigned N) {
PILA *pila;

  pila = (PILA *) malloc (sizeof(PILA));	/* memoria para la estructura */
  if (pila == NULL) {
    printf("\nERROR, no se ha podido dar memoria a la pila.");
    exit(1);
  }
  pila -> s = (elemento *) calloc (N, sizeof(elemento)); /* memoria para los */
  if (pila -> s == NULL) {                               /* N elementos */
    printf("\nERROR, no se ha podido dar memoria a los %d elementos de la pila.", N);
    exit(1);
  }

  /* inicialmente el puntero a la base coincide con el del top */
  pila -> st = pila -> s;
  pila -> sb = (pila -> s + N);	/* puntero al lmite */
  pila -> s = NULL;
  return pila;
}

/****************************************************************************/
/* Funcin que inserta en la pila un elemento e incrementando el top.       */
/****************************************************************************/
void push(PILA *pila, elemento e) {

	if (pila -> s == NULL) {
	  *(pila -> st) = e;
	  pila -> s = pila -> st;
	}
	else {
	  (*pila).s++;
	  if (pila -> s == pila -> sb) {	/* toda la pila ocupada */
	    printf("\nNo queda ms espacio en la pila.");
	    exit(1);
	  }
	  *(pila -> s) = e;
	}
}


/***************************************************************************/
/* Funcin que extrae de la pila un elemento e si esta tiene al menos uno. */
/***************************************************************************/
void pop(PILA *pila, elemento *e) {

  if (PILA_VACIA(pila -> s)) {
    printf("\nERROR, la pila est vaca.");
    exit(1);
  }
  *e = *(pila -> s);			/* devuelve el elemento */
  if (NUMELPILA(pila) == 1)
    pila -> s = NULL;
  else
    (*pila).s--;
}

/***************************************************************************/
/* Funcin que libera de la memoria toda la pila, la estructura y lo que se
 haba reservado para los N elementos.                                     */
/***************************************************************************/
void Libera_pila(PILA *pila) {

  free(pila -> st);
  free(pila);
}

